<?php

namespace FiloBlu\ExtElasticsearch\Plugin;

/**
 * Class ElasticsearchPlugin
 * @package FiloBlu\Elasticsearch\Plugin
 */
class ElasticsearchPlugin
{

    /**
     * @var \Psr\Log\LoggerInterface
     */
    protected $_logger;

    /**
     * ElasticsearchPlugin constructor.
     * @param \Psr\Log\LoggerInterface $logger
     */
    public function __construct(\Psr\Log\LoggerInterface $logger)
    {
        $this->_logger = $logger;
    }

    /**
     * @param \Magento\Elasticsearch\Model\Client\Elasticsearch $subject
     * @param array $fields
     * @param $index
     * @param $entityType
     * @return array
     */
    public function beforeAddFieldsMapping(\Magento\Elasticsearch\Model\Client\Elasticsearch $subject, array $fields, $index, $entityType)
    {
        try {
            if (!isset($fields['sku'])) {
                return null;
            }

            $fields['sku']['index'] = 'not_analyzed';

            return [$fields, $index, $entityType];

        } catch (\Exception $e) {
            $this->_logger->critical($e->getMessage());
            return null;
        }
    }
}